 /* dtoq - convert Fortran program from double to quadruple precision */
%{
#include "flex.h"
#include "fortran.h"
int debug = 0;				/* non-zero for debug output when */
					/* compiled with -DDEBUG */
int hp_output = 1;			/* non-0 for quad-precision output */
%}
		/* increase lex table sizes for lex */
%a 4500
%e 1500
%k 1500
%n  500
%o 9500
%p 3000

a	[aA]
b	[bB]
c	[cC]
d	[dD]
e	[eE]
f	[fF]
g	[gG]
h	[hH]
i	[iI]
j	[jJ]
k	[kK]
l	[lL]
m	[mM]
n	[nN]
o	[oO]
p	[pP]
q	[qQ]
r	[rR]
s	[sS]
t	[tT]
u	[uU]
v	[vV]
w	[wW]
x	[xX]
y	[yY]
z	[zZ]
				    /* digits with optional embedded blanks */
B		([0-9]|[0-9][0-9 ]*[0-9])
					/* decimal digit */
D		[0-9]
					/* floating-point exponent */
E		[QDEqde][-+]?{B}
					/* optional whitespace */
W		[ \t]*
					/* number */
N		{B}
%%
^[*Cc].*$			ECHO;	/* copy comments unchanged */

^\t[1-9]			{	/* handle tabbed continuation */
				    outstr("     ");
				    output(yytext[1]);
				}

^\t0 |
^\t				outstr("      "); /* handle tabbed initial */

^{W}{d}{o}{u}{b}{l}{e}{W}{p}{r}{e}{c}{i}{s}{i}{o}{n}  convert_declaration(yytext);

^{W}{r}{e}{a}{l}"*"8		convert_declaration(yytext);

^{W}{i}{m}{p}{l}{i}{c}{i}{t}{W}{r}{e}{a}{l}"*"8		convert_declaration(yytext);

^"     "[^ 0]			ECHO;	/* copy continuation line prefixes */

{N}{p}{N}*[A-Za-z]{N}"."{N}	ECHO;	/* copy FORMAT items intact */

{N}*[A-Za-z]{N}"."{N}		ECHO;	/* copy FORMAT items intact */

"."{n}{o}{t}"." |
"."{a}{n}{d}"." |
"."{x}{o}{r}"." |
"."{o}{r}"." |
"."{g}{e}"." |
"."{g}{t}"." |
"."{l}{e}"." |
"."{l}{t}"." |
"."{e}{q}"." |
"."{e}{q}{v}"." |
"."{n}{e}"." |
"."{n}{e}{q}"."			ECHO;	/* recognize logical operators */

{N}"."{N}*({W}{E})? |
{N}*"."{N}({W}{E})? |
{N}{W}{E}			convert_number(yytext) ;

{i}{d}{i}{n}{t}/{W}"("		cvtstr("iqint"); /* handle name conversions */
{i}{d}{n}{i}{n}{t}/{W}"("	cvtstr("iqnint");
{d}{b}{l}{e}/{W}"("		cvtstr("qext");	/* [24-May-2002] fixed: was dbleq */
{d}{i}{n}{t}/{W}"("		cvtstr("qint");
{d}{l}{o}{g}/{W}"("		cvtstr("qlog");
{d}{l}{o}{g}10/{W}"("		cvtstr("qlog10");
{d}{m}{a}{x}0/{W}"("		cvtstr("qmax0");
{d}{m}{a}{x}1/{W}"("		cvtstr("qmax1");
{d}{m}{i}{n}0/{W}"("		cvtstr("qmin0");
{d}{m}{i}{n}1/{W}"("		cvtstr("qmin1");
{d}{m}{o}{d}/{W}"("		cvtstr("qmod");
{d}{n}{i}{n}{t}/{W}"("		cvtstr("qnint");
{d}{a}{b}{s}/{W}"("		cvtstr("qabs");
{d}{a}{c}{o}{s}/{W}"("		cvtstr("qacos");
{d}{a}{s}{i}{n}/{W}"("		cvtstr("qasin");
{d}{a}{t}{a}{n}/{W}"("		cvtstr("qatan");
{d}{a}{t}{a}{n}2/{W}"("		cvtstr("qatan2");
{d}{c}{o}{s}/{W}"("		cvtstr("qcos");
{d}{c}{o}{s}{h}/{W}"("		cvtstr("qcosh");
{d}{d}{i}{m}/{W}"("		cvtstr("qdim");
{d}{e}{x}{p}/{W}"("		cvtstr("qexp");
{d}{f}{l}{o}{a}{t}/{W}"("	cvtstr("qfloat");
{d}{s}{i}{g}{n}/{W}"("		cvtstr("qsign");
{d}{s}{i}{n}/{W}"("		cvtstr("qsin");
{d}{s}{i}{n}{h}/{W}"("		cvtstr("qsinh");
{d}{s}{q}{r}{t}/{W}"("		cvtstr("qsqrt");
{d}{t}{a}{n}/{W}"("		cvtstr("qtan");
{d}{t}{a}{n}{h}/{W}"("		cvtstr("qtanh");

{d}{r}{a}{n}{d}/{W}"("		cvtstr("qrand");/* common extensions */
{d}1{m}{a}{c}{h}/{W}"("		cvtstr("q1mach");

{B}{h}				outhollerith(yytext);

'[^']*(''[^']*)*'		outquotedstring(yytext);

[A-Za-z][A-Za-z0-9]+ |
[0-9]+ |
\n |
.				ECHO;
%%

#include <common.h>
